<template>
  <div>
    
    <!-- Contenido -->
    <div class="">
      <!--<div class="titSecCard">Descargar Excel de Certificación de Puntos de Venta</div>-->
      <v-card style="background-color: #fafafa;">
        <v-container fluid>
          <div class="indicaciones" align="center" justify="center">
            Selecciona periodo de tiempo de descarga
          </div>
          
          <v-row align="center" justify="center">
            <!-- Negocio -->
            <!-- FECHA INICIO -->
            <v-col cols="4">
              <div class="titCampos">Fecha Inicio</div>
              <v-flex>
                <v-menu
                  ref="menuInicio"
                  v-model="menuInicio"
                  :close-on-content-click="false"
                  :nudge-right="40"
                  
                  transition="scale-transition"
                  offset-y
                  min-width="290px"
                >
                  <template v-slot:activator="{ on }">
                    <v-text-field
                      ref="fechaInicioTF"
                      outlined
                      dense
                      v-model="fechaInicio"
                      placeholder="Selecciona una fecha inicio"
                      prepend-icon
                      readonly
                      v-on="on"
                      :rules="[() => !!fechaInicio || 'Debes seleccionar la fecha Inicio']"
                      prepend-inner-icon="mdi-calendar-month"
                    ></v-text-field>
                  </template>

                  <v-date-picker
                    v-model="fechaInicio"
                    @input="menuInicio = false"
                    header-color="#ffc900"
                    color="#ffeeb2"
                    @click="$refs.menuInicio.save(fechaInicio)"
                  >
                    
                  </v-date-picker>
                </v-menu>
              </v-flex>
            </v-col>
            <!-- FECHA FIN -->
            <v-col cols="4">
              <div class="titCampos">Fecha Fin</div>
              <v-flex>
                <v-menu
                  ref="menuFin"
                  v-model="menuFin"
                  :close-on-content-click="false"
                  :nudge-right="40"
                  
                  transition="scale-transition"
                  offset-y
                  min-width="290px"
                >
                  <template v-slot:activator="{ on }">
                    <v-text-field
                      ref="fechFinTF"
                      outlined
                      dense
                      v-model="fechaFin"
                      placeholder="Selecciona una fecha fin"
                      prepend-icon
                      readonly
                      v-on="on"
                      :rules="[() => !!fechaFin || 'Debes seleccionar la fecha fin']"
                      prepend-inner-icon="mdi-calendar-month"
                    ></v-text-field>
                  </template>

                  <v-date-picker
                    v-model="fechaFin"
                    @input="menuFin = false"
                    header-color="#ffc900"
                    color="#ffeeb2"
                    @click="$refs.menuFin.save(fechaFin)"
                  >
                  </v-date-picker>
                </v-menu>
              </v-flex>
            </v-col>
          </v-row>
          <br />
          <v-row align="center" justify="center">
            <!-- BUSCAR -->
            <v-col cols="4"></v-col>
            <v-col cols="4">
              <v-btn block color="primary" @click="getReport" dark>
                <strong style="font-size: 16px; color: #000;">Descargar</strong>
              </v-btn>
            </v-col>
            <v-col cols="4"></v-col>
          </v-row>
        </v-container>
      </v-card>
    </div>
    <!-- Fin conSecc -->
  </div>
</template>
<style scoped></style>
<script>
import FileSaver from "file-saver";
import router from "@/router";
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
import axios from "axios";

const serviceCommons = store.state.serviceCommons;
export default {
  name : "DescargaExcelPopUpVue",
  props: {
    idNegocio: Number,
    idGerente:Number
  },
  data() {
    return {

      menuInicio: false,
      menuFin: false,
      
      fechaInicio: "",
      fechaFin: "",

      metadata: {
        
      },
      search: "",
      

    };
  },
  methods: {
     getReport() {
      const self = this;
      let fecha_inicio = "";
      let fecha_fin = ""
      if(this.fechaInicio){
        let dia = this.fechaInicio.split("-")[2];
        let mes = this.fechaInicio.split("-")[1];
        let anio = this.fechaInicio.split("-")[0];
        fecha_inicio = dia +"/" + mes + "/" + anio;
        
      }

      if(this.fechaFin){
        let dia = this.fechaFin.split("-")[2];
        let mes = this.fechaFin.split("-")[1];
        let anio = this.fechaFin.split("-")[0];
        fecha_fin = dia +"/" + mes + "/" + anio;
      }

      let url =
        "/franquicia/dashboard/reportes/secure/cobertura/?" +
        "fechaInicial=" +
        fecha_inicio +
        "&fechaFinal=" +
        fecha_fin +
        "&idNegocio=" +
        this.idNegocio;

        if(this.idGerente){
          url = url + "&idGerente=" +
            this.idGerente;
        }

      let axiosConfig = {
        headers: {
          "content-type": "application/x-www-form-urlencoded;charset=utf-8",
        },
      };

      axios
        .get(url, {
          headers: {
            "Content-Type": "application/json;charset=UTF-8",
          },
          data: {}, // envío un cuerpo (aunque sea un objeto vacío)
        })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;

              if (data) {
                this.exportToExcel(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },

    exportToExcel(data) {
      const dataFinal = { data };
      const self = this
      axios({
        method: "post",
        url: "/json/convert/secure/array/excel",
        responseType: "blob",
        data: dataFinal,
      })
        .then((response) => {
          if (response.headers["content-type"] !== "application/json") {
            let nombreFile = "Cobertura_"+self.fechaInicio +"_"+self.fechaFin;
            FileSaver.saveAs(response.data, nombreFile);
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function () {});
    },
    validaFecha() {

      if (this.fechaInicio != null) {
        var fi = new Date();
        var ff = new Date();

        var fechaInicial = this.fechaInicio.split("-");
        var fechaFinal = this.fechaFin.split("-");

        fi.setFullYear(fechaInicial[2], fechaInicial[1], fechaInicial[0]);
        ff.setFullYear(fechaFinal[2], fechaFinal[1], fechaFinal[0]);

        if (ff >= fi) {
          return true;
        } else {
          //alert("LA FECHA FIN DEBE SER MAYOR A LA INICIAL");
          this.fechaFin = null;
          this.$refs.menuFin.save(null);
          return false;
        }
      } else {
        //alert("SIN FECHA INICIAL");
        this.fechaFin = null;
        this.$refs.menuFin.save(null);
      }
    },
    descargaExcel(){

      var fi = true;
      var ff = true;
      var ne = true;

      if(!this.fechaInicio){
        this.$refs.fechFinTF.validate(true); 
        fi = false; 
      }

      if(!this.fechaFin){
        this.$refs.fechaInicioTF.validate(true);
        ff=false;
      }

      if(fi && ff && ne){

        var dataObject = {
            
            fechaInicio: this.fechaInicio.replace("-","").replace("-",""),
            fechaFin :this.fechaFin.replace("-","").replace("-","")
          };

        router.push({
            name : "",
            params : {
              datosBusqueda : serviceCommons.objectToBase64(dataObject)
            }
        });
      }

        
    }
  },

  created() {

    

  },
};
</script>
